package netscape.softupdate;

abstract class InstallObject {
   SoftwareUpdate softUpdate;

   InstallObject(SoftwareUpdate var1) {
      this.softUpdate = var1;
   }

   protected abstract void Prepare() throws SoftUpdateException;

   protected abstract void Complete() throws SoftUpdateException;

   public abstract String toString();

   protected abstract void Abort();

   protected abstract boolean CanUninstall();

   protected abstract boolean RegisterPackageNode();

   public native boolean NativeDoesFileExist(String var1) throws SoftUpdateException;
}
