package netscape.softupdate;

import java.util.Enumeration;

final class VersionRegistry implements RegistryErrors {
   private VersionRegistry() {
   }

   protected static native String componentPath(String var0);

   protected static native VersionInfo componentVersion(String var0);

   protected static native String getDefaultDirectory(String var0);

   protected static native int setDefaultDirectory(String var0, String var1);

   protected static native int installComponent(String var0, String var1, VersionInfo var2);

   protected static int installComponent(String var0, String var1, VersionInfo var2, int var3) {
      int var4 = installComponent(var0, var1, var2);
      if (var4 == 0) {
         var4 = setRefCount(var0, var3);
      }

      return var4;
   }

   protected static native int deleteComponent(String var0);

   protected static native int validateComponent(String var0);

   protected static native int inRegistry(String var0);

   protected static native int close();

   protected static Enumeration elements() {
      return new VerRegEnumerator();
   }

   protected static native int setRefCount(String var0, int var1);

   protected static native Integer getRefCount(String var0);

   protected static int uninstallCreate(String var0, String var1) {
      String var2 = convertPackageName(var0);
      return uninstallCreateNode(var2, var1);
   }

   protected static native int uninstallCreateNode(String var0, String var1);

   private static String convertPackageName(String var0) {
      String var1 = var0;
      boolean var3 = false;
      if (var0.startsWith("/")) {
         var3 = true;
      }

      for(int var4 = var0.indexOf(95); var4 != -1; var4 = var1.indexOf(95, var4 + 2)) {
         StringBuffer var5 = new StringBuffer(var1);
         var5.insert(var4 + 1, '_');
         var1 = var5.toString();
      }

      String var2 = var1.replace('/', '_');
      if (var3) {
         StringBuffer var6 = new StringBuffer(var2);
         var6.setCharAt(0, '/');
         var2 = var6.toString();
      }

      return var2;
   }

   protected static int uninstallAddFile(String var0, String var1) {
      String var2 = convertPackageName(var0);
      return uninstallAddFileToList(var2, var1);
   }

   protected static native int uninstallAddFileToList(String var0, String var1);

   protected static int uninstallFileExists(String var0, String var1) {
      String var2 = convertPackageName(var0);
      return uninstallFileExistsInList(var2, var1);
   }

   protected static native int uninstallFileExistsInList(String var0, String var1);

   protected static native String getUninstallUserName(String var0);
}
